<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Constructors</title>
</head>
<body>
  <div class="wrap">
    <header>
      <form>
        <label for="author">
          <span>Author</span>
          <select id="author" name="author">
            <option value="Taras Shevchenko">Taras Shevchenko</option>
            <option value="Ivan Franko">Ivan Franko</option>
            <option value="Vasyl Stys">Vasyl Stys</option>
            <option value="Oles Gonchar">Oles Gonchar</option>
          </select>
        </label>

        <label for="message">
          <span>Message</span>
          <textarea placeholder="Your Message" id="message"></textarea>
        </label>

        <button type="submit">Send Message</button>
      </form>
    </header>
    
    <section>
      <ul id="message_list">
        <!-- <li data-id="awda">
            <div class="message__date">
              27/01/2018
            </div>
            <div class="message__author">
              <b>Ivan Franko</b>
            </div>
            <div class="message__text">
              Ночі безмірнії, ночі безсоннії...
            </div>
            <div class="message__controls">
              <button class="_skipMessage">Skip</button>
              <button class="_answerMessage">Answer</button>
            </div>

            <ul class="answers"></ul>
        </li> -->
      </ul>

    </section>

  </div>

  <script>
  /*
    Задание на классы.
  
    Создать класс Message конструктор которого состоит из следующих полей:
    id, author, text, date, answers
  
    У этого класса будет два метода:
    SkipMessage() -> которое должно найти сообщение и удалить его из массива.
    AnswerMessage()-> должно открыть поле ввода, в который вы сможете ввести ответ
    SendAnswer() -> метод который «отравляет» ответ, при этом обновляя поле ответа(answers) в вашем объекте с сообщением.
  
    В метод SendAnswer нужно передать объект класса Answer который наследуется от класса Message,
    Но еще дополнительно будет иметь поле parentId.
  

    message = {
      id: '',
      author: '',
      text: '',
      date: '',
      answers: [
        {
          id: '',
          author: '',
          text: '',
          date: '',
          parentId: '',
          answers: [
  
          ]
        }
      ]
    }
  
    +Bonus: После создании сообщение добавляется в массив со всеми сообщениями, которые потом будут выводится на экран.
  
    _ _ _
  
    Задание можно разделить на две части:
      1. Создание самого сообщения:
      id->выдается автоматом
      Author-> селект с выбором автора
      Text -> текст сообщения
      date -> автоматически в момент создания
  
      Все данные беруться с формы. Массив с сообщениями передается в функцию рендера, которая генерирует сам список.
  
      2. Ответ на сообщение


  */

  const SendMessage = (e) => {
    e.preventDefault();
    let f = e.target;
    let author = f.querySelector('#author');
    let text = f.querySelector('#message');
    let msg = {};
    if (f.elements.parentId) {
      msg = new Answer(author.value, text.value, f.elements.parentId.value);
      f.remove();
    } else {
      msg = new Message(author.value, text.value);
      author.selectedIndex = 0;
      text.value = null;
    }
    msg.render();
  }

  let form = document.querySelector('.wrap form');
  form.addEventListener('submit', SendMessage);

  class Message {
    constructor (author, text) {
      let date = new Date();
      this.id = date.getTime();
      this.author = author;
      this.text = text;
      this.date = date.toLocaleString();
    }

    skipMessage(e) {
      let li = e.target.closest('li');
      li.remove();
    }

    answerMessage(e) {
      let li = e.target.closest('li');
      let answerForm = document.createElement('form');
      answerForm.innerHTML = form.innerHTML;
      answerForm.className = 'answer-form';
      let parentId = document.createElement('input');
      parentId.type = 'hidden';
      parentId.name = 'parentId';
      parentId.value = li.dataset.id;
      answerForm.appendChild(parentId);
      answerForm.addEventListener('submit', SendMessage);
      li.appendChild(answerForm);
    }

    createMessage() {
      let li = document.createElement('li');
      li.dataset.id = this.id;
      li.innerHTML = `<div class="message__date">${this.date}</div>
            <div class="message__author">
              <b>${this.author}</b>
            </div>
            <div class="message__text">${this.text}</div>
            <div class="message__controls">
              <button class="_skipMessage">Skip</button>
              <button class="_answerMessage">Answer</button>
            </div>
            <ul class="answers"></ul>`;
      li.querySelector('._skipMessage').addEventListener('click', this.skipMessage);
      li.querySelector('._answerMessage').addEventListener('click', this.answerMessage);
      return li;
    }

    render() {
      let msg = this.createMessage();
      document.querySelector('section #message_list').appendChild(msg);
    }
  }

  class Answer extends Message {
    constructor (author, text, parent) {
      super (author, text);
      this.parent = parent;
    }

    render() {
      let answer = this.createMessage();
      document.querySelector('li[data-id="' + this.parent + '"] .answers').appendChild(answer);
    }
  }

  </script>
</body>
</html>
